package com.ssiisample.imageProcessingSample2;

import android.app.Activity;
import android.content.Context;
import android.content.pm.ActivityInfo;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;

public class ImageProcessingSample extends Activity {

	OverlayGLSurfaceView mGLSurfaceView = null;
	SensorCallback mSensorCallback=null;
	
	int mPreviewWidth=240,mPreviewHeight=160;		//カメラのプレビューサイズ
	float mScaleWidth, mScaleHeight;				//画面サイズとプレビューサイズの比率
	int mIntImage[]=null;							//ARGB8888の画像格納用
	ColorConvert mColorConvert=new ColorConvert();	//色変換用クラス
	ColorConvert.YUVtoRGB mYUV2RGB;
	ColorConvert.YUVtoRGB565 mYUV2RGB565;
	
	CameraCallback mCameraCallback;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		//setContentView(R.layout.main);//元々の表示画面をコメントアウト    
		//画面の向きを横で固定
		this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
		//全画面表示
		this.getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
		//スリープ無効
		this.getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		//タイトルの非表示
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		//レイアウト設定
		final ViewGroup.LayoutParams layoutParams = new ViewGroup.LayoutParams(
				ViewGroup.LayoutParams.FILL_PARENT,
				ViewGroup.LayoutParams.FILL_PARENT);
		
		//カメラ映像の表示
		//setContentView(new CameraCallback(this), layoutParams);//CameraCallbackを描画画面に設定
		//独自プレビュー描画画面
		//addContentView(new GraphicsView(this), layoutParams);
		
		
		mSensorCallback=new SensorCallback(this);
		mCameraCallback = new CameraCallback(this);
		
		setContentView(R.layout.main);
		mGLSurfaceView=(OverlayGLSurfaceView)findViewById(R.id.OpenGLClass);
		addContentView(mCameraCallback, layoutParams);
	}

	//独自プレビュー画面
	private class GraphicsView extends View{
		Paint paint;
		public GraphicsView(Context c){
			super(c);
			paint=new Paint();
		}
		@Override
		protected void onDraw(Canvas canvas){
			if(mIntImage==null)return;
			canvas.drawRGB(128, 128, 128);
			//canvas.scale(mScaleWidth, mScaleHeight);
			canvas.scale(mScaleHeight, mScaleHeight);//画面の高さにあわせて拡大
			canvas.drawBitmap(mIntImage, 0, mPreviewWidth, 0, 0, mPreviewWidth, mPreviewHeight, false, paint);
			//invalidate();
		}
		
	}
	
	
	//初期化用
	public void initImageData(int preview_width, int preview_height,int screen_width,int screen_height){
		Log.i("initImageData", "preview width:"+preview_width+" height:"+preview_height);
		mPreviewWidth=preview_width;
		mPreviewHeight=preview_height;
		mScaleWidth=(float)screen_width/mPreviewWidth;
		mScaleHeight=(float)screen_height/mPreviewHeight;
		mIntImage=new int[mPreviewWidth*mPreviewHeight];
		//mYUV2RGB = mColorConvert.newYUVtoRGB(mPreviewWidth, mPreviewHeight, 2,3,3);
		mYUV2RGB565 = mColorConvert.newYUVtoRGB565(mPreviewWidth, mPreviewHeight, 2,3,3);
		mSensorCallback.start(SensorManager.SENSOR_DELAY_GAME);
		if (mGLSurfaceView != null)
			mGLSurfaceView.setTextureSize(mPreviewWidth);
		
	}
	//画像処理
	public void cameraLoop(byte yuv[]){

		mYUV2RGB565.getTexture(yuv, mGLSurfaceView.mUShortData);// YUV420->RGB565
		mGLSurfaceView.draw(mSensorCallback.getRotateXY(), mSensorCallback.getRotateXZ()/2);
		////YUVからRGBへ変換
		//mYUV2RGB.getFast(yuv, mIntImage);
	}
	
}
