package com.ssiisample.imageProcessingSample2;


import java.util.List;

import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;

public class SensorCallback implements SensorEventListener{
	private boolean mRegisteredSensor;
	private SensorManager mSensorManager = null;
	boolean mStartFlag=false;
	

	public SensorCallback(Context c){
		mSensorManager = (SensorManager) c.getSystemService(Context.SENSOR_SERVICE);
		mRegisteredSensor = false;
	}

	public void onAccuracyChanged(Sensor sensor, int accuracy) {

	}
	
	float mAccX=1,mAccY=0,mAccZ=0;
	float mLastAccX,mLastAccY,mLastAccZ;
	int mOriX,mOriY,mOriZ;
	
	public float getRotateXY(){
		if(mStartFlag)return (float)(90-Math.atan2(mAccX, mAccY) * 360 / 2 / 3.14159);
		return 0;
	}
	public float getRotateXZ(){
		if(mStartFlag)return (float)(90-Math.atan2(mAccX, mAccZ) * 360 / 2 / 3.14159);
		return 0;
	}

	public void onSensorChanged(SensorEvent event) {
		// 加速度の取得
		if (event.sensor.getType() == Sensor.TYPE_ACCELEROMETER) {


			mLastAccX=mAccX;
			mLastAccY=mAccY;
			mLastAccZ=mAccZ;

			mAccX =  (float) ((event.values[0] +mLastAccX)/2.)  ;
			mAccY =  (float) ((event.values[1] +mLastAccY)/2.)  ;
			mAccZ =  (float) ((event.values[2] +mLastAccZ)/2.) ;


		}
		if (event.sensor.getType() == Sensor.TYPE_ORIENTATION) {
			mOriX = ((int) (event.values[0])  ) ;
			mOriY = ((int) (event.values[1])  ) ;
			mOriZ = ((int) (event.values[2])  ) ;		
		}

	}

	public void start(int delay) {
		mStartFlag=true;
		List<Sensor> sensors = mSensorManager
				.getSensorList(Sensor.TYPE_ORIENTATION);

		if (sensors.size() > 0) {
			Sensor sensor = sensors.get(0);
			mRegisteredSensor = mSensorManager.registerListener(this, sensor,delay);
		}
		sensors = mSensorManager.getSensorList(Sensor.TYPE_ACCELEROMETER);
		if (sensors.size() > 0) {
			Sensor sensor = sensors.get(0);
			mRegisteredSensor = mSensorManager.registerListener(this, sensor,delay);
		}
	}

	public void pause() {
		mStartFlag=false;
		if (mRegisteredSensor) {
			mSensorManager.unregisterListener(this);
			mRegisteredSensor = false;
		}
	}

	public void stop() {
		mStartFlag=false;
		mSensorManager.unregisterListener(this);
	}

}
