package com.ssiisample.imageProcessingSample3;

import java.io.IOException;

import android.content.Context;
import android.hardware.Camera;
import android.hardware.Camera.Size;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class CameraCallback extends SurfaceView implements
		Camera.PreviewCallback, SurfaceHolder.Callback {
	private Camera _camera;

	public FrameRateChecker mFPS = new FrameRateChecker(10);


	ImageProcessing mClass = null;

	public CameraCallback(ImageProcessing c) {		//描画画面の準備
		super((Context)c);
		mClass=c;
		SurfaceHolder sHolder = getHolder();
		sHolder.addCallback(this);
		sHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
		this.setFocusable(true);
		this.requestFocus();
	}

	public void surfaceCreated(SurfaceHolder holder){  //描画画面の生成時にカメラを起動
		_camera = Camera.open();
		//_camera = Camera.open(1);//2.3以降なら利用するカメラを変更できる
	}
	public void surfaceDestroyed(SurfaceHolder holder){//描画画面の破棄時にカメラを終了
		stopPreviewCallback();
		_camera.stopPreview();
		_camera.release();
		_camera = null;
		mClass.releaseImageData();
	}
	public void surfaceChanged(SurfaceHolder holder,int format,int width,int height){
		//String size_str[]=RefCamera.getSupportedPreviewSizeString(_camera,_camera.getParameters());
		//Size previewSize=RefCamera.setSupportedPreviewSize(_camera,0);
		Size previewSize=RefCamera.setNearestPreviewSize(_camera,320,240);
		
		mClass.initImageData(previewSize.width, previewSize.height, width, height);
		try {_camera.setPreviewDisplay(holder);}
		catch (IOException e) {}
		
		
		if(RefCamera.isEnablePreviewWithBuffer()){
			RefCamera.setCallbackBuffer(_camera);
			RefCamera.setPreviewCallbackWithBuffer(_camera,this);
		}
		else startPreviewCallback();
			
		_camera.startPreview();	
			
	}
	
	
	
	public void onPreviewFrame(byte[] data, Camera camera) {
		mFPS.measurement();
		if(RefCamera.isEnablePreviewWithBuffer()){
			mClass.cameraLoop(data);
			RefCamera.addCallbackBuffer(camera,data);
		}else{
			stopPreviewCallback();
			mClass.cameraLoop(data);
			startPreviewCallback();
		}
		invalidate();//画像処理が終わった時点で再描画
	}
	private void stopPreviewCallback(){
		_camera.setPreviewCallback(null);
	}
	private void startPreviewCallback(){
		_camera.setPreviewCallback(this);
	}	



}